using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace Mesware.MesControl.DataProvider
{
	/// <summary>
	/// Interface which should be implemented by all sources
	/// of data for <see cref="MEScontrolDataReader"/>.
	/// </summary>
	public interface IDataReaderSource
	{
		/// <summary>
		/// Gets the <see cref="Type"/> of item.
		/// </summary>
		/// <returns><see cref="Type"/> of item.</returns>
		Type GetItemType();

		/// <summary>
		/// Gets data of source.
		/// </summary>
		/// <returns>Data of source.</returns>
		IEnumerable GetData();

		/// <summary>
		/// Sets the evalParams for source.
		/// </summary>
		/// <param name="parameters">Parameters for source.</param>
		void SetParameters(MEScontrolParameterCollection parameters);
	}
}
