using System;
using System.Collections.Generic;
using System.Text;
using System.Data.Common;

namespace Mesware.MesControl.DataProvider
{
	public class MEScontrolDataAdapter : DbDataAdapter
	{
		// Methods
		public MEScontrolDataAdapter()
		{
		}

		public MEScontrolDataAdapter(MEScontrolCommand selectCommand)
			: this()
		{
			this.SelectCommand = selectCommand;
		}

		private MEScontrolDataAdapter(MEScontrolDataAdapter from)
			: base(from)
		{
		}

		public MEScontrolDataAdapter(string selectCommandText, MEScontrolConnection selectConnection)
			: this()
		{
			this.SelectCommand = new MEScontrolCommand(selectCommandText, selectConnection);
		}

		public MEScontrolDataAdapter(string selectCommandText, string selectConnectionString)
			: this()
		{
			MEScontrolConnection connection = new MEScontrolConnection(selectConnectionString);
			this.SelectCommand = new MEScontrolCommand(selectCommandText, connection);
		}

		public MEScontrolDataAdapter(string selectCommandText, MEScontrolConnection selectConnection, object targetObject)
			: this()
		{
			this.SelectCommand = new MEScontrolCommand(selectCommandText, selectConnection, targetObject);
		}

		public MEScontrolDataAdapter(string selectCommandText, string selectConnectionString, object targetObject)
			: this()
		{
			MEScontrolConnection connection = new MEScontrolConnection(selectConnectionString);
			this.SelectCommand = new MEScontrolCommand(selectCommandText, connection, targetObject);
		}
	}
}
