using System;
using System.Collections.Generic;
using System.Text;
using Stimulsoft.Report.Dictionary;
using Mesware.MesControl.Model;

namespace Mesware.MesControl.DataProvider
{
	public class AvgDimensionalValueFunctionService : StiAggregateFunctionService
	{
		// Fields
    private long count;
		private DimensionalValue summary;
		private bool first;

    // Methods
    public override void CalcItem(object value)
    {
        this.count += 1;
				if (value == null || value == DBNull.Value) return;
				if (first)
					summary = (DimensionalValue)value;
				else
					summary += (DimensionalValue)value;
				first = false;
    }

    public override Type GetResultType()
    {
			return typeof(DimensionalValue);
    }

    public override object GetValue()
    {
        if (this.count == 0L)
        {
            return new DimensionalValue("", 0);
        }
        return (this.summary / this.count);
    }

		public override void SetValue(object value)
		{
			this.summary = (DimensionalValue)value;
			this.count = 1;
		}

    public override void Init()
    {
        if (!base.RunningTotal || base.IsFirstInit)
        {
					first = true;
          this.count = 0L;
        }
    }

    public override void RestoreState(string stateName)
    {        
    }

    public override void SaveState(string stateName)
    {        
    }

    // Properties
    public override bool RecureParam
    {
        get
        {
            return true;
        }
    }

    public override string ServiceName
    {
        get
        {
            return "AvgDV";
        }
    }

	}
}
