using System;
using System.Collections.Generic;
using System.Text;
using Stimulsoft.Report.Dictionary;
using System.Collections;

namespace Mesware.MesControl.DataProvider
{
	public class ConstructArrayFunctionService : StiAggregateFunctionService
	{
		private List<object> data;

		public override void CalcItem(object value)
		{
			data.Add(value); 			
		}

		public override Type GetResultType()
		{
			return typeof(object[]);
		}

		public override object GetValue()
		{
			if (data==null)
				return new object[0];
			return data.ToArray(); 
		}

		public override void SetValue(object value)
		{
			this.data.Clear();
			data.AddRange((object[])value); 
		}

		public override void Init()
		{
			if (!base.RunningTotal || base.IsFirstInit)
				data = new List<object>(); 
		}

		public override bool RecureParam {
			get { return true; }
		}

		public override void RestoreState(string stateName)
		{			
		}

		public override void SaveState(string stateName)
		{			
		}

		public override string ServiceName {
			get {
				return "ConstructArray";
			}
		}
	}
}
