using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Stimulsoft.Report.Dictionary.Design;
using Stimulsoft.Report.Dictionary;
using System.Windows.Forms;
using Mesware.MesControl.DataProvider.Properties;

namespace Mesware.MesControl.DataProvider
{
	[TypeConverter(typeof(StiSqlDatabaseConverter))]
	public class MEScontrolDatabase : StiSqlDatabase
	{
		public override string ServiceName {
			get { return TranslationResources.MEScontrolConnection; }
		}

		protected override string DataAdapterType {
			get { return "Mesware.MesControl.DataProvider.MEScontrolDataAdapterService"; }
		}

		public override DialogResult Edit(bool newDatabase)
		{
			using (StiSqlDatabaseEditForm form = new StiSqlDatabaseEditForm(this)) {
				if (newDatabase)
					form.Text = TranslationResources.NewMEScontrolConnection;
				else
					form.Text = TranslationResources.EditMEScontrolConnection;

				form.tbName.Text = this.Name;
				form.tbAlias.Text = this.Alias;
				form.tbConnectionString.Text = this.ConnectionString;
				if (form.ShowDialog()==DialogResult.OK) {
					this.Name = form.tbName.Text;
					this.Alias = form.tbAlias.Text;
					this.ConnectionString = form.tbConnectionString.Text;
				}
				return form.DialogResult;
			}
		}


		/// <summary>
		/// Creates a new object of the type StiFirebirdDatabase.
		/// </summary>
		public MEScontrolDatabase()
			: this(string.Empty, string.Empty)
		{
		}


		/// <summary>
		/// Creates a new object of the type StiFirebirdDatabase.
		/// </summary>
		public MEScontrolDatabase(string name, string connectionString)
			: base(name, connectionString)
		{
		}


		/// <summary>
		/// Creates a new object of the type StiFirebirdDatabase.
		/// </summary>
		public MEScontrolDatabase(string name, string alias, string connectionString)
			: base(name, alias, connectionString)
		{
		}

		/// <summary>
		/// Creates a new object of the type StiFirebirdDatabase.
		/// </summary>
		public MEScontrolDatabase(string name, string alias, string connectionString, bool promptUserNameAndpassword)
			: base(name, alias, connectionString, promptUserNameAndpassword)
		{
		}
	}
}
