using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Stimulsoft.Report.Dictionary.Design;
using Stimulsoft.Report.Dictionary;
using System.Data;

namespace Mesware.MesControl.DataProvider
{
	[TypeConverter(typeof(StiSqlSourceConverter))]
	public class MEScontrolSource : StiSqlSource
	{
		protected override Type ConvertDbTypeToTypeInternal(int sqlType)
		{
			return typeof(object);
		}

		public override Type GetParameterTypesEnum()
		{
			return typeof(DbType);
		}

		public override StiDataParameter AddParameter()
		{
			StiDataParameter parameter = new StiDataParameter("Parameter", string.Empty, (int)DbType.Object, 0);
			Parameters.Add(parameter);
			return parameter;
		}

		public virtual StiDataParameter AddParameter(string name, string expression, DbType type, int size)
		{
			StiDataParameter parameter = AddParameter();
			parameter.Name = name;
			parameter.Expression = expression;
			parameter.Type = (int)type;
			parameter.Size = size;

			return parameter;
		}

		public override void UpdateParameters()
		{
			if (this.DataTable!=null) {
				InvokeConnecting();
				foreach (StiDataParameter parameter in Parameters) {
					((MEScontrolDataAdapter)DataAdapter).SelectCommand.Parameters[parameter.Name].Value = parameter.GetParameterValue();
				}
				DataTable dataTable = this.DataTable;
				dataTable.Rows.Clear();

				((MEScontrolDataAdapter)DataAdapter).Fill(dataTable);

				CheckColumnsIndexs();
			}
		}

		protected override string DataAdapterType {
			get { return "Mesware.MesControl.DataProvider.MEScontrolDataAdapterService"; }
		}

		public MEScontrolSource()
			: this("", "", "")
		{
		}

		public MEScontrolSource(string nameInSource, string name)
			: this(nameInSource, name, name)
		{
		}

		public MEScontrolSource(string nameInSource, string name, string alias)
			: this(nameInSource, name, alias, string.Empty)
		{

		}

		public MEScontrolSource(string nameInSource, string name, string alias, string sqlCommand)
			:
			base(nameInSource, name, alias, sqlCommand)
		{
		}

		public MEScontrolSource(string nameInSource, string name, string alias, string sqlCommand,
			bool connectOnStart)
			:
		base(nameInSource, name, alias, sqlCommand, connectOnStart)
		{
		}

		public MEScontrolSource(string nameInSource, string name, string alias, string sqlCommand,
			bool connectOnStart, bool reconnectOnEachRow)
			:
			base(nameInSource, name, alias, sqlCommand, connectOnStart, reconnectOnEachRow)
		{
		}

		public MEScontrolSource(string nameInSource, string name, string alias, string sqlCommand,
			bool connectOnStart, bool reconnectOnEachRow, int commandTimeout)
			:
			base(nameInSource, name, alias, sqlCommand, connectOnStart, reconnectOnEachRow, commandTimeout)
		{
		}
	}	
}
