using System;
using System.Collections.Generic;
using System.Text;
using Stimulsoft.Report.Dictionary;
using Mesware.MesControl.Model;

namespace Mesware.MesControl.DataProvider
{
	public class MaxDimensionalValueFunctionService : StiAggregateFunctionService
	{
		 // Fields
    private DimensionalValue maximun;

    // Methods
    public override void CalcItem(object value)
    {
        if ((value!=null) && (value!=DBNull.Value))
        {
            DimensionalValue val = (DimensionalValue)value;
						if (maximun.MeasureTypeFormula == null || this.maximun < val)
            {
							this.maximun = val;
            }
        }
    }

    public override Type GetResultType()
    {
        return typeof(DimensionalValue);
    }

    public override object GetValue()
    {
			return this.maximun;
    }

		public override void SetValue(object value)
		{
			this.maximun = (DimensionalValue)value;
		}

    public override void Init()
    {
        if (!base.RunningTotal || base.IsFirstInit)
        {
					this.maximun = new DimensionalValue();
        }
    }

    public override void RestoreState(string stateName)
    {
    }

    public override void SaveState(string stateName)
    {
    }

    // Properties
    public override bool RecureParam
    {
        get
        {
            return true;
        }
    }

    public override string ServiceName
    {
        get
        {
            return "MaxDV";
        }
    }
	}
}
